"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var path_template_to_parameter_names_1 = require("./path-template-to-parameter-names");
var toParameterPattern = function toParameterPattern(template, patterns) {
    var userParameterPatterns = typeof patterns === 'undefined' ? [] : Object.keys(patterns).map(function (name) {
        var patternOrUndefined = patterns[name];
        var pattern = typeof patternOrUndefined === 'undefined' ? null : patternOrUndefined;
        return { name: name, pattern: pattern };
    });
    var parameterNames = path_template_to_parameter_names_1.pathTempalteToParameterNames(template);
    var parameters = parameterNames.map(function (name) {
        var userPattern = userParameterPatterns.find(function (_ref) {
            var n = _ref.name;
            return n === name;
        });
        var pattern = typeof userPattern === 'undefined' ? null : userPattern.pattern;
        return { name: name, pattern: pattern };
    });
    return parameters;
};
exports.toParameterPattern = toParameterPattern;