"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var path_template_to_parameter_names_1 = require("./_/path-template-to-parameter-names");
var to_parameter_pattern_1 = require("./_/to-parameter-pattern");
var path = function path(template, patterns) {
    var parameterNames = path_template_to_parameter_names_1.pathTempalteToParameterNames(template);
    return function (params) {
        if (parameterNames.some(function (name) {
            return typeof params[name] !== 'string';
        })) {
            return null;
        }
        var parameterPattern = to_parameter_pattern_1.toParameterPattern(template, patterns);
        if (parameterPattern.some(function (_ref) {
            var name = _ref.name,
                pattern = _ref.pattern;

            return pattern !== null && params[name].match(pattern) === null;
        })) {
            return null;
        }
        return parameterNames.reduce(function (a, name) {
            return a.split('{' + name + '}').join(encodeURIComponent(params[name]));
        }, template);
    };
};
exports.path = path;